/* /////////////////////////////////////////////////////////////////////////////
 * File:        recls_compiler_watcom.h
 *
 * Purpose:     Watcom C++ specific types and includes for the recls API.
 *
 * Created:     23rd September 2003
 * Updated:     2nd November 2003
 *
 * Copyright:   Synesis Software Pty Ltd, (c) 2003. All rights reserved.
 *
 * Home:        http://www.synesis.com.au/software
 *              http://recls.org/
 *
 * ////////////////////////////////////////////////////////////////////////// */


#if !defined(RECLS_INCL_H_RECLS_COMPILER) && \
    !defined(RECLS_DOCUMENTATION_SKIP_SECTION)
# error recls_compiler_watcom.h cannot be included directly. Include recls.h
#else

#ifndef RECLS_COMPILER_IS_WATCOM
# error recls_compiler_watcom.h can only be used for Watcom C++ compiler builds
#endif /* !RECLS_COMPILER_IS_WATCOM */

/* File version */
#ifndef RECLS_DOCUMENTATION_SKIP_SECTION
# define RECLS_VER_H_RECLS_COMPILER_WATCOM_MAJOR    1
# define RECLS_VER_H_RECLS_COMPILER_WATCOM_MINOR    1
# define RECLS_VER_H_RECLS_COMPILER_WATCOM_REVISION 1
# define RECLS_VER_H_RECLS_COMPILER_WATCOM_EDIT     2
#endif /* !RECLS_DOCUMENTATION_SKIP_SECTION */

/** \file recls_compiler_watcom.h Watcom C++-specific compiler definitions for the \ref group_recls  API */

/* /////////////////////////////////////////////////////////////////////////////
 * Includes
 */

#include <stddef.h>

/* /////////////////////////////////////////////////////////////////////////////
 * Namespace
 */

#if !defined(RECLS_NO_NAMESPACE)
namespace recls
{
#endif /* !RECLS_NO_NAMESPACE */

/* /////////////////////////////////////////////////////////////////////////////
 * Typedefs
 */

/** \def recls_byte_t The byte type for the \ref group_recls  API */
/** \def recls_sint8_t The 8-bit signed integer type for the \ref group_recls  API */
/** \def recls_uint8_t The 8-bit unsigned integer type for the \ref group_recls  API */
/** \def recls_sint16_t The 16-bit signed integer type for the \ref group_recls  API */
/** \def recls_uint16_t The 16-bit unsigned integer type for the \ref group_recls  API */
/** \def recls_sint32_t The 32-bit signed integer type for the \ref group_recls  API */
/** \def recls_uint32_t The 32-bit unsigned integer type for the \ref group_recls  API */
/** \def recls_sint64_t The 64-bit signed integer type for the \ref group_recls  API */
/** \def recls_uint64_t The 64-bit unsigned integer type for the \ref group_recls  API */

typedef unsigned char       recls_byte_t;

typedef signed char         recls_sint8_t;
typedef unsigned char       recls_uint8_t;

typedef signed short        recls_sint16_t;
typedef unsigned short      recls_uint16_t;

typedef signed long         recls_sint32_t;
typedef unsigned long       recls_uint32_t;

typedef signed __int64      recls_sint64_t;
typedef unsigned __int64    recls_uint64_t;

/** \def recls_char_a_t The ANSI character type for the \ref group_recls  API */
/** \def recls_char_w_t The Unicode character type for the \ref group_recls  API */
typedef char                recls_char_a_t;
typedef wchar_t             recls_char_w_t;

/* /////////////////////////////////////////////////////////////////////////////
 * Namespace
 */

#if !defined(RECLS_NO_NAMESPACE)
} /* namespace recls */
#endif /* !RECLS_NO_NAMESPACE */

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* RECLS_INCL_H_RECLS_COMPILER */

/* ////////////////////////////////////////////////////////////////////////// */
