/* /////////////////////////////////////////////////////////////////////////////
 * File:        recls_jni_util.h
 *
 * Purpose:     
 *
 * Created      21st November 2003
 * Updated:     21st November 2003
 *
 * Copyright:   Synesis Software Pty Ltd, (c) 2003. All rights reserved.
 *
 * Home:        www.synesis.com.au/software
 *
 * ////////////////////////////////////////////////////////////////////////// */


#include <recls.h>
#include <jni.h>
#include <time.h>

#ifdef RECLS_PLATFORM_IS_WIN32
# include <winstl_time_functions.h>
#endif /* RECLS_PLATFORM_IS_WIN32 */

/* ////////////////////////////////////////////////////////////////////////// */

#if !defined(RECLS_NO_NAMESPACE)
using recls::recls_rc_t;
using recls::recls_bool_t;
using recls::recls_char_t;
using recls::recls_time_t;
using recls::recls_filesize_t;

using recls::RECLS_FAILED;
using recls::RECLS_SUCCEEDED;
#endif /* !RECLS_NO_NAMESPACE */

/* ////////////////////////////////////////////////////////////////////////// */

#if defined(__cplusplus)
static const char	CLASSNAME_ENTRY[]			=	"Lorg/recls/Entry;";
static const char	CLASSNAME_SEARCH[]			=	"Lorg/recls/Search;";
static const char	CLASSNAME_RECLSX[]			=	"Lorg/recls/ReclsException;";
static const char	CLASSNAME_UNSUPPORTEDX[]	=	"Ljava/lang/UnsupportedOperationException;";
static const char	CLASSNAME_ILLEGALSTATEX[]	=	"Ljava/lang/IllegalStateException;";
static const char	CLASSNAME_NOSUCHELEMENTX[]	=	"Ljava/lang/NoSuchElementException;";
static const char	FIELDNAME_HENTRY[]			=	"m_hEntry";
static const char	FIELDNAME_HSRCH[]			=	"m_hSearch";
#else
#define				CLASSNAME_ENTRY					"Lorg/recls/Entry;"
#define				CLASSNAME_SEARCH				"Lorg/recls/Search;"
#define				CLASSNAME_RECLSX				"Lorg/recls/ReclsException;"
#define				CLASSNAME_UNSUPPORTEDX			"Ljava/lang/UnsupportedOperationException;"
#define				CLASSNAME_ILLEGALSTATEX			"Ljava/lang/IllegalStateException;"
#define				CLASSNAME_NOSUCHELEMENTX		"Ljava/lang/NoSuchElementException;"
#define				FIELDNAME_HENTRY				"m_hEntry"
#define				FIELDNAME_HSRCH					"m_hSearch"
#endif /* __cplusplus */

/* ////////////////////////////////////////////////////////////////////////// */

void ThrowException(JNIEnv *henv, char const *className, char const *message);
void ThrowReclsException(JNIEnv *henv, char const *message, recls_rc_t code);


jstring StringFromRange(JNIEnv *henv, recls_char_t const *from, recls_char_t const *to);

jsize SafeStringUTFLength(JNIEnv *henv, jstring str);
jsize SafeStringLength(JNIEnv *henv, jstring str);

char const *SafeStringUTFChars(JNIEnv *henv, jstring str, jboolean *isCopy);
jchar const *SafeStringChars(JNIEnv *henv, jstring str, jboolean *isCopy);

/* ////////////////////////////////////////////////////////////////////////// */
